﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////

var oShell = new ActiveXObject("WScript.Shell");

//var objWMIService = null;
//objWMIService = GetObject("winmgmts:\\\\.\\root\\CIMV2");
//var colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Battery","WQL",48);

var oBatteries, oBatteries2, BatteryInfo, CellInfo;
var PowerStatus = System.Machine.PowerStatus;
var bZeile = "0";
var cZeile = "0";
var firstrun = 1;

function Init()
{
	battCollect.innerText = SomeText[1];
	battCollect.style.display="block";
	battDetails.style.display="none";

	content.style.backgroundColor = System.Gadget.Settings.read("gadgetcolourback");
	content.style.color = System.Gadget.Settings.read("gadgetcolourlabel");

	headimg.src = "/img/Flyout/batthead.png";
    setInterval(onTimer,3000);
//	binfo.innerText="test";
}

function onTimer()
{
	if (firstrun == "1")
	{
	    firstrun = "0";
	}
	else
	{
		GetPowerStatus();
	    firstrun = "0";
	}
}


// --------------------------------------------------------------------
// Get the machine power information.
// --------------------------------------------------------------------
function GetPowerStatus()
{
	if (firstrun == 0)
	{
		clearTable("b");
		clearTable("c");
		bZeile = 0;
		cZeile = 0;
	}

	oBatteries = GetObject("WinMgmts:").InstancesOf ("Win32_Battery");
	oBatteries2 = GetObject("WinMgmts:").InstancesOf ("Win32_PortableBattery");

	ShowDevices(oBatteries, "Battery", "Name");
	ShowDevices(oBatteries, "Battery", "DeviceID");
	ShowDevices(oBatteries, "Battery", "BatteryStatus");
	ShowDevices(oBatteries, "Battery", "EstimatedRunTime");
	ShowDevices(oBatteries, "Battery", "EstimatedChargeRemaining");
	ShowDevices(oBatteries, "Battery", "FullChargeCapacity");
	ShowDevices(oBatteries, "Battery", "DesignCapacity");
	ShowDevices(oBatteries, "Battery", "DesignVoltage");
	ShowDevices(oBatteries2, "Battery2", "Manufacturer");
	ShowDevices(oBatteries2, "Battery2", "Name");
	ShowDevices(oBatteries, "Battery", "Chemistry");
	ShowDevices(oBatteries2, "Battery2", "DesignCapacity");
	ShowDevices(oBatteries2, "Battery2", "DesignVoltage");

	inote.innerText = "\n" + SomeText[0];
}

function ShowDevices(instances, className, Name)
{
	var enumInstances = new Enumerator(instances);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == Name)
			{
				if (Name == "BatteryStatus" && PowerStatus.isBatteryCharging == true)
				{
					newTableRow("b",prop.Name, BattStat[prop.Value -1] + " " + BattStat[11]);
				}
				else if (Name == "BatteryStatus")
				{
					newTableRow("b",prop.Name, BattStat[prop.Value -1] + " " + BattStat[12]);
				}
				else if (Name == "EstimatedRunTime")
				{
					if(prop.Value == 255) // no battery
					{
						newTableRow("b",prop.Name, BattStat[13]);
					}
					else if(!System.Machine.PowerStatus.isPowerLineConnected)//running on battery
					{
						var remaining = 0;
						remaining = prop.Value;
						var hRemaining = Math.floor(remaining / 60);
						var mRemaining = remaining % 60;

						if(remaining != 71582788 && remaining != -1)
							newTableRow("b",prop.Name, hRemaining + ":" + padnumber(mRemaining) + "h");
						else
						{
							newTableRow("b",prop.Name, BattStat[14]);
						}
					}
					else if(System.Machine.PowerStatus.isBatteryCharging)
					{
						newTableRow("b",prop.Name, BattStat[5]); //Charging
					}
					else
					{
						newTableRow("b",prop.Name, BattStat[2]); //Fully charged
					}
				}
				else if (Name == "EstimatedChargeRemaining")
				{
					if(prop.Value == 255) // no battery
					{
						newTableRow("b",prop.Name, BattStat[13]);
					}
					else {
						newTableRow("b",BattStat[15], prop.Value+"%");
					}
				}
				else if (Name == "FullChargeCapacity" && className == "Battery")
				{
					if (prop.Value != null)
					{
						newTableRow("b",prop.Name, prop.Value + " mWh");
					}
					else
					{
						newTableRow("b",prop.Name, "-- mWh");
					}
				}
				else if (Name == "DesignCapacity" && className == "Battery")
				{
					if (prop.Value != null)
					{
						newTableRow("b",prop.Name, prop.Value + " mWh");
					}
					else
					{
						newTableRow("b",prop.Name, "-- mWh");
					}
				}
				else if (Name == "DesignVoltage" && className == "Battery")
				{
					if (prop.Value != null)
					{
						newTableRow("b",prop.Name, prop.Value + " mV");
					}
					else
					{
						newTableRow("b",prop.Name, "-- mV");
					}
				}
				else if (Name == "Name" && className == "Battery")
				{
					newTableRow("b",prop.Name, prop.Value);
				}
				else if (Name == "DeviceID")
				{
					newTableRow("b",prop.Name, prop.Value);
				}
				else if (Name == "Chemistry")
				{
					newTableRow("c",prop.Name, Chem[Validate(oBatteries, oBatteries2, "Chemistry") -1]);
				}
				else if (Name == "Manufacturer")
				{
					newTableRow("c",prop.Name, prop.Value);
				}
				else if (Name == "Name")
				{
					newTableRow("c",prop.Name, prop.Value);
				}
				else if (Name == "DesignCapacity")
				{
					if (prop.Value != null)
					{
						newTableRow("c",prop.Name, prop.Value+" mWh");
					}
					else
					{
						newTableRow("c",prop.Name, "-- mWh");
					}
				}
				else if (Name == "DesignVoltage")
				{
					if (prop.Value != null)
					{
						newTableRow("c",prop.Name, prop.Value+" mV");
					}
					else
					{
						newTableRow("c",prop.Name, "-- mV");
					}
				}
				else
				{
					newTableRow("b",prop.Name, prop.Value);
				}
			}
		}
	}
	battCollect.style.display="none";
	battDetails.style.display="block";
}

function newTableRow(num, name, value)
{
	if (num == "b")
	{
		var TR = bTabelle.insertRow();
	}
	if (num == "c")
	{
		var TR = cTabelle.insertRow();
	}
	var TD1 = document.createElement("td");
	TD1.width = "35%";
	var TD1text = document.createTextNode(name);
	TD1.appendChild(TD1text);
	var TD2 = document.createElement("td");
	var TD2text = document.createTextNode(value);
	TD2.width = "65%";
	TD2.appendChild(TD2text);
	TR.appendChild(TD1);
	TR.appendChild(TD2);
	bZeile ++;
	cZeile ++;
}

function clearTable(num)
{
	if (num == "b")
	{
		var rowsnum = bTabelle.rows.length;
		for (var i = 0; i < rowsnum; rowsnum--)
		{
			bTabelle.deleteRow(i);
		}
	}
	if (num == "c")
	{
		var rowsnum = cTabelle.rows.length;
		for (var i = 0; i < rowsnum; rowsnum--)
		{
			cTabelle.deleteRow(i);
		}
	}
}
function padnumber(num)
{
	if(num < 10)
		return "0"+num;
	else
		return num;
}


function Validate(inst, inst2, eName)
{
	var enumInst = new Enumerator(inst);
	for ( ; !enumInst.atEnd(); enumInst.moveNext() )
	{
		var oDevice = enumInst.item();
		var msg = new String();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == eName)
			{
				var val1 = prop.Value;
			}
		}
	}
	enumInst = new Enumerator(inst2);
	for ( ; !enumInst.atEnd(); enumInst.moveNext() )
	{
		var oDevice = enumInst.item();
		var msg = new String();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == eName)
			{
				var val2 = prop.Value;
			}
		}
	}
	if (val1 == val2)
	{
		return val1;
	}
	else
	{
		return val2;
	}

}

